
#include <QImageReader>

#include "ImageThumbnailThread.h"

ImageThumbnailThread::ImageThumbnailThread(const QSize& aSize, QObject* parent)
    : QThread(parent), iSize(aSize), iThreadCancelled(false)
{
}

ImageThumbnailThread::~ImageThumbnailThread()
{
	
}

void ImageThumbnailThread::run()
{
	while (!iThreadCancelled && iImageList.size() > 0)
	{
		QImageReader reader;
		reader.setFileName(iImageList[0].first);
		QSize imageSize = reader.size();
		
		imageSize.scale(iSize, Qt::KeepAspectRatio);
		reader.setScaledSize(imageSize);
		QImage image(reader.read());
		emit ThumbnailCreated(iImageList[0].second, image);
		iImageList.removeAt(0);
	}
}

void ImageThumbnailThread::Cancel()
{
	iThreadCancelled = true;
}

void ImageThumbnailThread::AddImage(QString aFilename, int aIndex)
{
	iImageList.append(QPair<QString, int>(aFilename, aIndex));
}
