#ifndef IMAGETHUMBNAILTHREAD_H
#define IMAGETHUMBNAILTHREAD_H

#include <QThread>
#include <QStringList>
#include <QSize>
#include <QPair>

class QImage;

class ImageThumbnailThread : public QThread
{
    Q_OBJECT

public:
    ImageThumbnailThread(const QSize& aSize, QObject* parent = 0);
    ~ImageThumbnailThread();

public:
	void run();
	void Cancel();
	
public slots:
	void AddImage(QString aFilename, int aIndex);
	
signals:
	void ThumbnailCreated(int aIndex, const QImage& aImage);
	
private:
	const QSize iSize;
	QList<QPair<QString, int> > iImageList;
	bool iThreadCancelled;
};

#endif // IMAGESEARCHTHREAD_H
